#! /bin/bash
Echo_Help_String()
{

	echo "Command : ipv4set";
	echo "Set Ethernet(eth0 / eth1) network setting"
	echo "Usage: ipv4set [eth0 / eth1] [static / dhcp] [ip] [netmask] [gateway]"
	echo "Set Ethernet(eth0 / eth1) DHCP"
	echo "Example 1:ipv4set (eth0 / eth1) dhcp"
	echo "Set Ethernet(eth0 / eth1) static network setting"
	echo "Example 2:ipv4set (eth0 / eth1) static 10.1.0.107 255.255.0.0 10.1.0.254"
	exit;
}
Killdhclient()
{
	while [ true ]
	do
	{
		Lan=$1;
		PID=`ps -aux | grep "dhclient" | grep $1 | awk 'NR==1{print}' | awk '{print $2}'`;
		if [ "$PID" = "" ];then
		{
			break;
		}
		fi
		kill $PID;
	}
	done
}
SetDHCPIP()
{

	mac_address=`cat /sys/class/net/$1/address | sed 's/://g'`;
	cable_address="ethernet_"$mac_address"_cable";
	/usr/lib/connman/test/set-ipv4-method $cable_address dhcp > /etc/null;
	echo "# $2" > /Init/interfaces/$1.ini;
}
SetStaticIP()
{
	#echo $1 $2 $3 $4 $5;
	mac_address=`cat /sys/class/net/$1/address | sed 's/://g'`;
	cable_address="ethernet_"$mac_address"_cable";
	#echo $1: $mac_address;
	#echo "cable_address:" $cable_address;
	/usr/lib/connman/test/set-ipv4-method $cable_address manual $3 $4 $5 > /etc/null;
	echo "# $2 $3 $4 $5" > /Init/interfaces/$1.ini;
}
check_ip() {
	IP=$1;
	Format=$2;
	if [[ $IP =~ ^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$ ]]; then
	{
		FIELD1=$(echo $IP|cut -d. -f1)
		FIELD2=$(echo $IP|cut -d. -f2)
		FIELD3=$(echo $IP|cut -d. -f3)
		FIELD4=$(echo $IP|cut -d. -f4)
		
		if [ $FIELD1 -le 255 -a $FIELD2 -le 255 -a $FIELD3 -le 255 -a $FIELD4 -le 255 ]; then
		{
			echo "$Format: $IP available."
		}
		else
		{	
			echo "$Format: $IP not available!"
			exit 0;
		}
		fi
	}
	else
	{
		echo "$Format: format error!"
		exit 0;
	}
	fi
}
GetIP()
{
	Mode=`cat /Init/interfaces/$1.ini | awk '{print $2}'`;
	if [ "$Mode" = "static" ];then
	{
		echo Lan: $1;
		echo Mode: $Mode;

		IP_Address=`cat /Init/interfaces/$1.ini | awk '{print $3}'`;
		echo IP_Address: $IP_Address;

		NetMask=`cat /Init/interfaces/$1.ini | awk '{print $4}'`;
		echo NetMask: $NetMask;

		Gateway=`cat /Init/interfaces/$1.ini | awk '{print $5}'`;
		echo Gateway: $Gateway;
	}
	elif [ "$Mode" = "dhcp" ];then
	{
		echo Lan: $1
		echo Mode: $Mode;
		Lan_ID=`/usr/lib/connman/test/get-services | grep Ethernet | grep -n $1 | awk '{print $1}' | sed 's/://g'`;
		echo Lan_ID: $Lan_ID;
		IP_Address=`/usr/lib/connman/test/get-services | grep "IPv4 = " | grep "Address" | sed 's/Address=/$/g' | awk -F'$' '{print $2}' | sed 's/ }//g' | awk NR==$Lan_ID'{print}'`;
		echo IP_Address: $IP_Address;
		NetMask=`/usr/lib/connman/test/get-services | grep "Netmask" | awk '{print $4}' | sed 's/Netmask=//g' | awk NR==$Lan_ID'{print}'`;
		echo NetMask: $NetMask;
		Gateway=`/usr/lib/connman/test/get-services | grep -n "Timeservers = " | awk '{print $4}' | sed "s/dbus.Array(\[dbus.String(u'//g" | sed "s/'),//g" | awk NR==$Lan_ID'{print}'`;
		echo Gateway: $Gateway;
	}
	fi
}